{-# OPTIONS -fglasgow-exts #-}

{-| This is a very silly module. Maybe it should go away?
-}

module Syntax.Name where

import Data.Generics
import Data.Char ( isAlpha )

-- Names ------------------------------------------------------------------

type Name = String

-- | Note: there are also literal references to \"_\", so it does not suffice
--   to change the constant 'dontCare' to get a sound behavior.
dontCare :: Name
dontCare = "_"

-- | Check if a name is an infix operator, i.e. if it starts with something
--   that isn'tAlpha. Something that starts with \'(\' is not an operator
--   either. This is a hack, to make some other hacks look good.
isOperator :: Name -> Bool
isOperator (c:s) = not $ isAlpha c || c == '_' || c == '('

-- | Indicates whether a name is a record field name or not.
data IsField = FieldName | LocalName
    deriving (Typeable, Data, Eq)
