
id (A : Set) : A -> A
id x = x

X : Set

idX : X -> X
idX = id

idX' : X -> X
idX' x = id x

data List (A : Set) : Set where
  nil : List A
  (::) : A -> List A -> List A

data Nat : Set where
  zero : Nat
  succ : Nat -> Nat

(+) : Nat -> Nat -> Nat
n + 0 = n
n + succ m = succ (n + m)

(++) (A:Set) : List A -> List A -> List A
[] ++ ys      = ys
(x::xs) ++ ys  = x :: (xs ++ ys)

{-
map (A, B : Set) : (A -> B) -> List A -> List B
map f [] = []
map f (x::xs) = f x :: map f xs

inc : Nat -> Nat
inc n = succ n

xs : List Nat
xs = [1,2,3]

test = map inc xs
-}
