
data (==){A:Set}(a:A) : A -> Set where
  refl : a == a

subst (A:Set)(x, y : A) : (P : A -> Set) -> x == y -> P x -> P y
subst P refl px = px

cong (A, B : Set)(x, y : A) : (f : A -> B) -> x == y -> f x == f y
cong f refl = refl

cong2 (A, B, C : Set)(x, y : A)(z, w : B) :
      (f : A -> B -> C) -> x == y -> z == w -> f x z == f y w
cong2 f refl refl = refl

cong3 (A, B, C, D : Set)(x, y : A)(z, w : B)(u, v : C) :
      (f : A -> B -> C -> D) -> x == y -> z == w -> u == v -> f x z u == f y w v
cong3 f refl refl refl = refl

