
-- # import Setoid
-- # import Order

sig Poset : Type extends Setoid where
  leq : PartialOrder (mkSetoid (mkSET el) eq)

mkPoset : (A:Setoid) -> PartialOrder A -> Poset
mkPoset A leq = struct el  = El A
		       eq  = A.eq
		       leq = leq

(<=) (A:Poset) : El A -> El A -> PROP
(<=) {A} = A.leq.rel

sig TotallyOrderedSet : Type extends Setoid where
  leq : TotalOrder (mkSetoid (mkSET el) eq)

TotalPoset : TotallyOrderedSet -> Poset
TotalPoset A =
  struct el  = A.el
	 eq  = A.eq
	 leq = A.leq

